import os
import tempfile
import datetime
import sys
from zeep import Client

#get account credentials from .sdf file 
def get_passport_from_sdf():
    with open(os.path.join(os.getcwd(),'.sdf'),'r+') as file:
        lines = file.readlines()
    file.close()

    passport = [(item.split('=')[0], item.split('=')[1].replace('\n','')) for item in lines]
    passport = dict(passport)
    return passport
#get_credentials_from_sdf


if __name__ == "__main__":
    client = Client('https://webservices.netsuite.com/wsdl/v2014_2_0/netsuite.wsdl')
    FileSearch = client.get_type('ns11:FileSearch')
    FileSearchBasic = client.get_type('ns5:FileSearchBasic')
    SearchStringField = client.get_type('ns0:SearchStringField')
    Record = client.get_type('ns0:RecordRef')
    Passport = client.get_type('ns0:Passport')

    remote = None
    localfile = sys.argv[1]
    passport = get_passport_from_sdf()
    credentials = Passport(email=passport['email'], password=passport['pass'], account=passport['account'], role="3")
    filesearch = FileSearch(basic=FileSearchBasic(name=SearchStringField(searchValue=localfile.split(os.path.sep)[-1], operator='is')))

    client.service.login(passport=credentials)
    response = client.service.search(searchRecord=filesearch)

    if response.body.searchResult.status.isSuccess:
        if response.body.searchResult.recordList is not None:
            remote = [{'internalid': file.internalId, 'name':file.name, 'parent':file.folder.name.replace(' : ',os.path.sep)} for file in response.body.searchResult.recordList.record if os.path.join(file.folder.name.replace(' : ',os.path.sep),file.name) == os.path.join('SuiteScripts',localfile)]

    if len(remote) > 0:
        record = Record(name= remote[0]['name'], internalId=remote[0]['internalid'], type='file')
        response = client.service.get(baseRef=record)
        tmpfile = remote[0]['name']

        #if there is another prev version exists then remove it
        if os.path.isfile(os.path.join(tempfile.gettempdir(),tmpfile)):
            os.remove(os.path.join(tempfile.gettempdir(),tmpfile)) 

        with open(os.path.join(tempfile.gettempdir(),tmpfile),'wb+') as  file:
            file.write(response.body.readResponse.record.content)
        file.close()
        print("Temp file:")
        print(os.path.join(tempfile.gettempdir(),tmpfile))
        
        subprocess.call(['code', '--diff', localfile, os.path.join(tempfile.gettempdir(),tmpfile)], shell=False);
    else:
        print("The file doesn't exists in your file cabinet")